         subroutine A1_wf_chex(q0,qv,ksf,kt1,ks1,p_m,kt2,ks2,p_r,
     &                        kt3,ks3,kj,wf1_re,wf1_im,md,ifl,irs,ivr)
******************************************************************
* inputs 
* q0 - virtual photon energy
* qv - virtual photon momentum
* kti - (i=1,2,3) isospins(1->proton,-1->neutron)
* ks1,ks2,ks3 - spin projection of 1,2,3 nucleon -1-> -1/2, 1-> 1/2
* kj - spin projection of he3 -1-> -1/2, 1-> 1/2
* idr - Flag of He3 WF (1,2 -> initialisation, 0->computation)
* md - method number in PV term, see  subroutine A1_z
* ifl - =1->pole case,= 2->PV case, 0 -> both
* irs = 22 pp rescattering, 21 pn rescattering
*       second digit indicates the isospin of the rescattered nucleon
* irs = 121 - np case - knocked-out neutron with rescattering off proton-r
* irs = 122 - np case - knocked-out neutron with rescattering off proton-s    
*
*inputs through common 
*/par/pi,pm,pmp,pmn,tm   : pi amd masses(constants)
*******************************************************************
        external phl_ch, phu_ch, un_1chex
        dimension p_m(3),p_r(3)
        common/par/pi,pm,pmp,pmn,tm,eb
	common/vphoton/Q2,q0c,qvc
	common/knocked/  p_f_x,  p_f_y,  p_f_z
        common/missing/  p_m_x,  p_m_y,  p_m_z
        common/recoil_r/ p_r_x,  p_r_y,  p_r_z
        common/recoil_s/ p_s_x,  p_s_y,  p_s_z
        common/conf_chex/isf,it1,is1,it2,is2,it3,is3,ij,iivr
        common/iflag/iflag
        common/enginv/s,its
        common/delta0/delta_r,delta_s
        common/pvstaff/accuracy,downlimit,uplimit 
        common/method/method
        common/emiss/ems
        common/imre_chex/im_or_re
        its    = irs
        iflag  = ifl
        method = md
        isf    = ksf
        it1    = kt1
        is1    = ks1
        it2    = kt2
        is2    = ks2
        it3    = kt3
        is3    = ks3
        ij     = kj
        iivr   = ivr
        accuracy  =  0.2
        downlimit = -1.0
        uplimit   =  1.0
        Q2  = qv**2 - q0**2
        qvc = qv
        q0c = q0

        p_m_x =  p_m(1)
        p_m_y =  p_m(2)
        p_m_z =  p_m(3)

        p_m_v = sqrt(p_m_x**2 + p_m_y**2 + p_m_z**2)
        t_2m = sqrt(4.0*pm**2 + p_m_v**2)-2.0*pm

        p_r_x =  p_r(1)
        p_r_y =  p_r(2)
        p_r_z =  p_r(3)

        p_s_x = -(p_m_x + p_r_x)  
        p_s_y = -(p_m_y + p_r_y) 
        p_s_z = -(p_m_z + p_r_z) 

        p_f_x = p_m_x
        p_f_y = p_m_y
        p_f_z = p_m_z + qv

        p_f = sqrt(p_f_x**2 + p_f_y**2 + p_f_z**2)
        pr  = sqrt(p_r_x**2 + p_r_y**2 + p_r_z**2)
        ps  = sqrt(p_s_x**2 + p_s_y**2 + p_s_z**2)


        E_f = sqrt(pm**2+p_f**2)
        E_r = sqrt(pm**2+pr**2)
        E_s = sqrt(pm**2+ps**2)
        T_r = E_r - pm
        T_s = E_s - pm
        delta_r = q0/qv*(T_r + T_s + eb) 
     &          +(2.*pm*(T_r + T_s) + p_m_v**2 - (T_r+T_s)**2)/(2.0*qv)

*        delta_r = q0/qv*(ems+t_2m) 
*     &          + (2.*pm*(ems+t_2m) + p_m_v**2 - (ems+t_2m)**2)/(4.0*qv)
        delta_s = delta_r
        
***************************************************************
        if(irs.eq.12)then
        s = 2*pm**2+2.0*(E_f*E_r -p_f_x*p_r_x -p_f_y*p_r_y -p_f_z*p_r_z) 
        elseif(irs.eq.13)then
        s = 2*pm**2+2.0*(E_f*E_s -p_f_x*p_s_x -p_f_y*p_s_y -p_f_z*p_s_z) 
        endif




        
        eps = 0.1
        qa  = 0.0
        qb  = 1.
        sum_re = 0.0
        im_or_re = 1
        call gadap2(qa,qb,phl_ch,phu_ch,un_1chex,eps,sum_re) 
        eps = 0.1
        qa  = 0.0
        qb  = 1.
        sum_im = 0.0
        im_or_re = -1
  	call gadap2(qa,qb,phl_ch,phu_ch,un_1chex,eps,sum_im)                

        wf1_re = sum_re
        wf1_im = sum_im         

        return
        end

        function phl_ch(q)
	phl_ch = 0.0
	return
	end
	function phu_ch(q)
	phu_ch = 2.0*acos(-1.0)
	return
	end

	function  un_1chex(q,phiq)
        dimension pv1(3), pv2(3)
        common/par/pi,pm,pmp,pmn,tm,eb
	common/vphoton/Q2,q0,qv
        common/missing/  p_m_x,  p_m_y,  p_m_z
        common/recoil_r/ p_r_x,  p_r_y,  p_r_z
        common/recoil_s/ p_s_x,  p_s_y,  p_s_z
        common/knocked/  p_f_x,  p_f_y,  p_f_z
 
        common/delta0/ delta_r, delta_s
        common/conf_chex/ksf,kt1,ks1,ktr2,ksr2,ktr3,ksr3,kj,ivr
        common/conf/kkt1,kks1,kt2,ks2,kt3,ks3,kkj


 	common/enginv/s,its
        common/iflag/iflag !iflag =1->pole case,= 2->PV case, 0 -> both
        common/pvstaff/accuracy,downlimit,uplimit 
        common/method/method
        common/imre_chex/im_or_re


        un_1chex = 0.0
        
	q_x      = q*cos(phiq)
	q_y      = q*sin(phiq)

 	pv1(3)   = p_m_z + delta_r
	pv1(2)   = p_m_y + q_y
	pv1(1)   = p_m_x + q_x
	p_1     = sqrt(pv1(1)**2+pv1(2)**2+pv1(3)**2)
*        write(6,*)delta_r,delta_s

                    ireg = 21
*       if(ktf.eq.-1)ireg = 12
       sigma0   = 1.0 !sigma_en(p_m_x,p_m_y,p_m_z,ireg)
       sigma1   =  1.0 !sigma_en(pv1(1),pv1(2),pv1(3),ireg)
       rsg = sqrt(sigma1/sigma0)
        
        if(its.eq.12)then
*        if (its.eq.22.or.its.eq.121) then
	pv2(3)   = p_r_z - delta_r
        pv2(2)   = p_r_y - q_y
	pv2(1)   = p_r_x - q_x
        elseif(its.eq.13)then
	pv2(3)   = p_r_z 
        pv2(2)   = p_r_y 
	pv2(1)   = p_r_x 
        endif
	p_2     = sqrt(pv2(1)**2+pv2(2)**2+pv2(3)**2)
        E_2     = sqrt(pm**2 + p_2**2)

****************************************************
* Calculation of t_on and t_off
****************************************************
****************************************************
*        Third nucleon 
****************************************************
        pv3_x = -(pv1(1) + pv2(1))
        pv3_y = -(pv1(2) + pv2(2))
        pv3_z = -(pv1(3) + pv2(3))
        pv3 = sqrt(pv3_x**2 + pv3_y**2 + pv3_z**2)
        E_3 = sqrt(pm**2 + pv3**2)
 

***************************************************
* knocked out nucleons final momentum
***************************************************
	p_r = sqrt(p_r_x**2 + p_r_y**2 + p_r_z**2)
	e_r = sqrt(pm**2 + p_r**2)

	p_s = sqrt(p_s_x**2 + p_s_y**2 + p_s_z**2)
	e_s = sqrt(pm**2 + p_s**2)

	p_f = sqrt(p_f_x**2 + p_f_y**2 + p_f_z**2)
	e_f = sqrt(pm**2 + p_f**2)


********************************************************
* knocked out nucleons  momentum  before rescattering
********************************************************
	p_tf_x   = pv1(1) 
	p_tf_y   = pv1(2)
	p_tf_z   = pv1(3) + qv
	p_tf     = sqrt(p_tf_x**2 + p_tf_y**2 + p_tf_z**2) 
	e_tf_on  = sqrt(pm**2 + p_tf**2)
	e_tf_off = tm - E_2 - E_3 + q0

	delta_pf2 = (p_f_x-p_tf_x)**2 + (p_f_y-p_tf_y)**2
     &                                + (p_f_z-p_tf_z)**2

  	t_on  = (e_f - e_tf_on)**2  - delta_pf2
	t_off = (e_f - e_tf_off)**2 - delta_pf2



**************************************************************
* defining the composition of nucleons before scattering
**************************************************************
        kkj  = kj
        kkt1 = kt1
        kks1 = ks1

        if(its.eq.12)then  ! rescattering with the second nucleons

	delta_p1r2 = (p_r_x-p_tf_x)**2 + (p_r_y-p_tf_y)**2 
     &                                 + (p_r_z-p_tf_z)**2
	u_on  = (e_r - e_tf_on)**2  - delta_p1r2
	u_off = (e_r - e_tf_off)**2 - delta_p1r2

        kt2 = - ktr2
        ks2 = - ksr2
        kt3 =   ktr3
        ks3 =   ksr3

        elseif(its.eq.13)then  ! rescattering with the third nucleons

	delta_p1r3 = (p_s_x-p_tf_x)**2 + (p_s_y-p_tf_y)**2 
     &                                 + (p_s_z-p_tf_z)**2
	u_on  = (e_s - e_tf_on)**2  - delta_p1r3
	u_off = (e_s - e_tf_off)**2 - delta_p1r3

        kt2 =   ktr2
        ks2 =   ksr2
        kt3 = - ktr3
        ks3 = - ksr3
        endif


        un_1_re_pole = 0.0
        un_1_re_pv   = 0.0
        
        if (iflag.eq.1.or.iflag.eq.0) then
************************************************************************
*       Pole term
************************************************************************
        wfre = 0.0
        wfim = 0.0
	call wf_he3_nb(kt1,ks1,pv1,kt2,ks2,pv2,kt3,ks3,kj,wfre,wfim,0) 

*        s   = 2.0*pm**2 + 2.0*e_f*pm
*        ton = -q**2
*        u_on = 2.0*pm**2 -2.0*e_f*pm + q**2
        f_on_re = 0.0
        f_on_im = 0.0
        ksfpr = -ksf
        if(its.eq.12)then
    	call f_pn_chex(ksfpr,ks2,ksr2,ksf,s,u_on,f_on_re,f_on_im,ivr)
        elseif(its.eq.13)then
    	call f_pn_chex(ksfpr,ks3,ksr3,ksf,s,u_on,f_on_re,f_on_im,ivr)
        endif

*        call f_NN_on(s,t_on,f_NN_on_re,f_NN_on_im,its)
        if(im_or_re.eq.1)then  ! real part
        un_1_pole = -(f_on_im*wfre + f_on_re*wfim)
        else  ! imaginary part
        un_1_pole =  (f_on_re*wfre - f_on_im*wfim)
        endif

        endif
        
        if  (iflag.eq.2.or.iflag.eq.0) then   
************************************************************************
*    PV term
************************************************************************
        a1_z_re = 0.0
        a1_z_im = 0.0
        call A1_z(method,accuracy,uplimit,q_x,q_y,a1_z_re,a1_z_im)

        if(im_or_re.eq.1)then  ! real part
        un_1_pv= -(f_on_re*a1_z_re - f_on_im*a1_z_im)
        else
        un_1_pv= -(f_on_re*a1_z_im + f_on_im*a1_z_re)
        endif

************************************************************************
        endif
        
        un_1chex =rsg*(1.0/4.0)*q*(un_1_pole + un_1_pv)/(2.0*pi)**2 

        return
	end


