        subroutine A2_wf(q0,qv,kt1,ks1,p_m,kt2,ks2,p_r,kt3,ks3,kj,
     &                                 wf2_re,wf2_im,mtd,irs)
******************************************************************
* only pole term in the double scattering amplitude it 
* calculates
*
* inputs 
* kti - (i=1,2,3) isospins(1->proton,-1->neutron)
* ks1,ks2,ks3 - spin projection of 1,2,3 nucleon -1-> -1/2, 1-> 1/2
* kj - spin projection of he3 -1-> -1/2, 1-> 1/2
* mtd - 1-> Double gadap2 method  2-> RADMUL(cern)
*
* irs = 221 electron scattering from proton with rescattered proton 
*           and spectator neutron
* irs = 212 electron scattering from proton with rescattered neutron
*           and spectator proton
* irs = 122 electron scattering from neutron with rescattered proton
*           and spectator proton
*
*inputs through common 
*/par/pi,pm,pmp,pmn,tm,eb   : pi amd masses(constants)
*/photon/Q2,q0,qv : photon(energy) data
*                  Nuclons
*/knocked/     p_f_x,  p_f_y,  p_f_z
*/missing/     p_m_x,  p_m_y,  p_m_z
*/recoil_r/    p_r_x,  p_r_y,  p_r_z
*/recoil_s/    p_s_x,  p_s_y,  p_s_z
*/delta2/delta0,delta2,delta3 
*******************************************************************
        dimension a(4), b(4),wk(17)
        external phl2, phu2, un_k2_re, un_k2_im, f_re, f_im   
        dimension p_m(3),p_r(3)
        common/par/pi,pm,pmp,pmn,tm,eb
	common/knocked/  p_f_x,  p_f_y,  p_f_z
        common/missing/  p_m_x,  p_m_y,  p_m_z
        common/recoil_r/ p_r_x,  p_r_y,  p_r_z
        common/recoil_s/ p_s_x,  p_s_y,  p_s_z
        common/conf/it1,is1,it2,is2,it3,is3,ij
        common/delta2/delta0,delta2,delta3
        common/sres/irs2,s_r,s_s
        common/nchanal/nal
        it1    = kt1
        is1    = ks1
        it2    = kt2
        is2    = ks2
        it3    = kt3
        is3    = ks3
        jj     = kj

        nal = 40
        p_m_x =  p_m(1)
        p_m_y =  p_m(2)
        p_m_z =  p_m(3)

        p_r_x =  p_r(1)
        p_r_y =  p_r(2)
        p_r_z =  p_r(3)

        p_s_x = -(p_m_x + p_r_x)  
        p_s_y = -(p_m_y + p_r_y) 
        p_s_z = -(p_m_z + p_r_z) 

        p_f_x = p_m_x
        p_f_y = p_m_y
        p_f_z = p_m_z + qv

        p_f = sqrt(p_f_x**2 + p_f_y**2 + p_f_z**2)
        pr  = sqrt(p_r_x**2 + p_r_y**2 + p_r_z**2)
        ps  = sqrt(p_s_x**2 + p_s_y**2 + p_s_z**2)

        irs2 = irs
        if(irs.eq.221)then
        E_f = sqrt(pmp**2+p_f**2)
        E_r = sqrt(pmp**2+pr**2)
        E_s = sqrt(pmn**2+ps**2)
        T_r = E_r - pmp
        T_s = E_s - pmn
        s_r = 2.0*(pmp**2+ E_f*E_r -p_f_x*p_r_x-p_f_y*p_r_y-p_f_z*p_r_z) 
        s_s =  pmp**2+pmn**2+2.0*(E_f*E_s - 
     &                p_f_x*p_s_x -p_f_y*p_s_y -p_f_z*p_s_z) 
        elseif(irs.eq.212)then
        E_f = sqrt(pmp**2+p_f**2)
        E_r = sqrt(pmn**2+pr**2)
        E_s = sqrt(pmp**2+ps**2)
        T_r = E_r - pmn
        T_s = E_s - pmp
        s_r =  pmp**2+pmn**2+2.0*(E_f*E_r - 
     &                p_f_x*p_r_x -p_f_y*p_r_y -p_f_z*p_r_z) 
        s_s = 2.0*(pmp**2+ E_f*E_s -p_f_x*p_s_x-p_f_y*p_s_y-p_f_z*p_s_z) 
        elseif(irs.eq.122)then
        E_f = sqrt(pmn**2+p_f**2)
        E_r = sqrt(pmp**2+pr**2)
        E_s = sqrt(pmp**2+ps**2)
        T_r = E_r - pmp
        T_s = E_s - pmp
        s_r =  pmp**2+pmn**2+2.0*(E_f*E_r - 
     &                p_f_x*p_r_x -p_f_y*p_r_y -p_f_z*p_r_z) 
        s_s =  pmp**2+pmn**2+2.0*(E_f*E_s - 
     &                p_f_x*p_s_x -p_f_y*p_s_y -p_f_z*p_s_z) 
        endif

        delta0 = q0/qv*(T_r + T_s + eb)
        delta2 = q0/qv*T_r
        delta3 = q0/qv*T_s
        
***************************************************************
        if (mtd.eq.1) then
        eps = 0.2
        qa  = 0.0
        qb  = 1.0
        call gadap2(qa,qb,phl2,phu2,un_k2_re,eps,sum_re)  	
        eps = 0.2
        qa  = 0.0
        qb  = 1.0
  	call gadap2(qa,qb,phl2,phu2,un_k2_im,eps,sum_im)                
        wf2_re = sum_re/16.0/((2*pi)**4)
        wf2_im = sum_im/16.0/((2*pi)**4)         
        else 
        n = 4
        a(1) = 0.0
        a(2) = 0.0 
        a(3) = 0.0
        a(4) = 0.0 
        b(1) = 1.0
        b(2) = 2*pi
        b(3) = 1.0
        b(4) = 2*pi
        minpts = 10
        maxpts = 2**4 + 2*N*(N + 1) + 1
        epss =0.5
        iwk = 17

        CALL RADMUL(F_re,N,A,B,MINPTS,MAXPTS,EPSS,WK,IWK,RESULT,
     &                                        RELERR,NFNEVL,IFAIL)
        wf2_re = result/16.0/((2*pi)**4)
        CALL RADMUL(F_im,N,A,B,MINPTS,MAXPTS,EPSS,WK,IWK,RESULT,
     &                                        RELERR,NFNEVL,IFAIL)
        wf2_im = result/16.0/((2*pi)**4)
        endif

        return
        end


        function phl2(q)
	phl2 = 0.0
	return
	end
	function phu2(q)
	phu2 = 2.0*acos(-1.0)
	return
	end
	function phll(q)
	phll = 0.0
	return
	end
	function phuu(q)
	phuu = 2.0*acos(-1.0)
	return
	end

        
       	function un_k2_re(qq,phiqq)
	external un_k3_re, phll , phuu
	common/q2_phi/qq2,phiqq2
	qq2    = qq
	phiqq2 = phiqq
	eps1 = 0.2
	call gadaps2(0.0,1.0,phll,phuu,un_k3_re,eps1,summ)
	un_k2_re = summ
	return
	end       	

        function un_k2_im(qq,phiqq)
	external un_k3_im, phll , phuu
	common/q2_phi/qq2,phiqq2
	qq2    = qq
	phiqq2 = phiqq
	eps1 = 0.2
        call gadaps2(0.0,1.0,phll,phuu,un_k3_im,eps1,summ)
	un_k2_im = summ       
	return
	end




	function  un_k3_re(qq3,phiqq3)
        dimension pv1(3), pv2(3), pvn1(3), pvn2(3)
	common/q2_phi/qq2,phiqq2
        common/par/pi,pm,pmp,pmn,tm,eb
	common/knocked/  p_f_x,  p_f_y,  p_f_z
        common/missing/  p_m_x,  p_m_y,  p_m_z
        common/recoil_r/ p_r_x,  p_r_y,  p_r_z
        common/recoil_s/ p_s_x,  p_s_y,  p_s_z
        common/conf/kt1,ks1,kt2,ks2,kt3,ks3,kj
        common/delta2/delta0,delta2,delta3
        common/sres/irs,s_r,s_s
        common/nchanal/nal
        un_k3_re = 0.0

        tilda2 = delta0 - delta3
        tilda3 = delta0 - delta2
        wfre   = 0.0
        wfim   = 0.0
        wfren  = 0.0
        wfimn  = 0.0

	q2_x     = qq2*cos(phiqq2)
	q2_y     = qq2*sin(phiqq2)
       
	q3_x     = qq3*cos(phiqq3)
	q3_y     = qq3*sin(phiqq3)

 	pv1(3)   = p_m_z + delta0
	pv1(2)   = p_m_y + q2_y + q3_y
	pv1(1)   = p_m_x + q2_x + q3_x
	p_1      = sqrt(pv1(1)**2+pv1(2)**2+pv1(3)**2)

	pv2(3)   = p_r_z - tilda2
        pv2(2)   = p_r_y - q2_y
	pv2(1)   = p_r_x - q2_x
	p_2      = sqrt(pv2(1)**2+pv2(2)**2+pv2(3)**2)
	
        pvn1(3)   = pv1(3) 
	pvn1(2)   = pv1(2)
	pvn1(1)   = pv1(1)
	pn_1      = p_1 

	pvn2(3)   = p_r_z - delta2
        pvn2(2)   = pv2(2)
	pvn2(1)   = pv2(1)
	pn_2      = sqrt(pvn2(1)**2+pvn2(2)**2+pvn2(3)**2)

        if(irs.eq.221)then
*************  pp case  rescattered particle is proton ----        
        its = 22
        t2  = -qq2**2
        call  f_NN_on(s_r,t2,f_1_on_re,f_1_on_im,its)   
*************** pn case spectator particle is neutron        
        its = 21
        t3  = -qq3**2
        call  f_NN_on(s_s,t3,f_2_on_re,f_2_on_im,its)

        elseif(irs.eq.212)then
*************  pn case  rescattered particle is neutron ----
        its = 21
        t2  = -qq2**2
        call  f_NN_on(s_r,t2,f_1_on_re,f_1_on_im,its)
*************** pp case spectator particle is proton
        its = 22
        t3  = -qq3**2
        call  f_NN_on(s_s,t3,f_2_on_re,f_2_on_im,its)   
       
        elseif(irs.eq.122)then
*************  np case  rescattered particle is proton ----
        its = 21
        t2  = -qq2**2
        call  f_NN_on(s_r,t2,f_1_on_re,f_1_on_im,its)
*************  np case  spectator particle is proton ----
        its = 21
        t3  = -qq3**2
        call  f_NN_on(s_s,t3,f_2_on_re,f_2_on_im,its)
        endif



**************************************************************
        call wf_he3_al(nal,kt1,ks1,pv1,kt2,ks2,pv2,kt3,ks3,kj,
     &               wfre,wfim,0)
       
         
	call wf_he3_al(nal,kt1,ks1,pvn1,kt2,ks2,pvn2,kt3,ks3,kj,
     &               wfren,wfimn,0)        
      
*	wfren = 0.0  !checking
*	wfimn = 0.0  !checking     
**************************************************************        
       
        part1 = (wfre+wfren) *
     &             (f_1_on_im*f_2_on_im  - f_1_on_re*f_2_on_re) 
        part2 = (wfim+wfimn) *
     &             (f_1_on_re*f_2_on_im  + f_1_on_im*f_2_on_re)        
       
       
!        part1 = (wfre+wfren) !*
!     &             (f_1_on_im*f_2_on_im  - f_1_on_re*f_2_on_re) 
!        part2 = (wfim+wfimn) !*
!     &             (f_1_on_re*f_2_on_im  + f_1_on_im*f_2_on_re)        
        
        un_k3_re = (part1 + part2)*qq2*qq3
        return
	end



	function  un_k3_im(qq3,phiqq3)
        dimension pv1(3), pv2(3), pvn1(3), pvn2(3)
	common/q2_phi/qq2,phiqq2
        common/par/pi,pm,pmp,pmn,tm,eb
	common/knocked/  p_f_x,  p_f_y,  p_f_z
        common/missing/  p_m_x,  p_m_y,  p_m_z
        common/recoil_r/ p_r_x,  p_r_y,  p_r_z
        common/recoil_s/ p_s_x,  p_s_y,  p_s_z
        common/conf/kt1,ks1,kt2,ks2,kt3,ks3,kj
        common/delta2/delta0,delta2,delta3
        common/sres/irs,s_r,s_s
        common/nchanal/nal
        un_k3_im = 0.0


        tilda2 = delta0 - delta3
        tilda3 = delta0 - delta2
         wfre  = 0.0
         wfim  = 0.0
         wfren = 0.0
         wfimn = 0.0

	q2_x     = qq2*cos(phiqq2)
	q2_y     = qq2*sin(phiqq2)
       
	q3_x     = qq3*cos(phiqq3)
	q3_y     = qq3*sin(phiqq3)

 	pv1(3)   = p_m_z + delta0
	pv1(2)   = p_m_y + q2_y + q3_y
	pv1(1)   = p_m_x + q2_x + q3_x
	p_1      = sqrt(pv1(1)**2+pv1(2)**2+pv1(3)**2)

	pv2(3)   = p_r_z - tilda2
        pv2(2)   = p_r_y - q2_y
	pv2(1)   = p_r_x - q2_x
	p_2      = sqrt(pv2(1)**2+pv2(2)**2+pv2(3)**2)
	
        pvn1(3)   = pv1(3) 
	pvn1(2)   = pv1(2)
	pvn1(1)   = pv1(1)
	pn_1      = p_1 

	pvn2(3)   = p_r_z - delta2
        pvn2(2)   = pv2(2)
	pvn2(1)   = pv2(1)
	pn_2      = sqrt(pvn2(1)**2+pvn2(2)**2+pvn2(3)**2)


        if(irs.eq.221)then
*************  pp case  rescattered particle is proton ----        
        its = 22
        t2  = -qq2**2
        call  f_NN_on(s_r,t2,f_1_on_re,f_1_on_im,its)   
*************** pn case spectator particle is neutron        
        its = 21
        t3  = -qq3**2
        call  f_NN_on(s_s,t3,f_2_on_re,f_2_on_im,its)

        elseif(irs.eq.212)then
*************  pn case  rescattered particle is neutron ----
        its = 21
        t2  = -qq2**2
        call  f_NN_on(s_r,t2,f_1_on_re,f_1_on_im,its)
*************** pp case spectator particle is proton
        its = 22
        t3  = -qq3**3
        call  f_NN_on(s_s,t3,f_2_on_re,f_2_on_im,its)   
       
        elseif(irs.eq.122)then
*************  np case  rescattered particle is proton ----
        its = 21
        t2  = -qq2**2
        call  f_NN_on(s_r,t2,f_1_on_re,f_1_on_im,its)
*************  np case  spectator particle is proton ----
        its = 21
        t3  = -qq3**2
        call  f_NN_on(s_s,t3,f_2_on_re,f_2_on_im,its)
        endif


**************************************************************
        call wf_he3_al(nal,kt1,ks1,pv1,kt2,ks2,pv2,kt3,ks3,kj,
     &               wfre,wfim,0)

         
	call wf_he3_al(nal,kt1,ks1,pvn1,kt2,ks2,pvn2,kt3,ks3,kj,
     &               wfren,wfimn,0)        
       
*	wfimn = 0.0   !checking
*	wfren = 0.0   !checking    

        part1 = (wfim+wfimn) *
     &             (f_1_on_im*f_2_on_im  - f_1_on_re*f_2_on_re) 
        part2 = (wfre+wfren) *
     &             (f_2_on_re*f_2_on_im  + f_1_on_im*f_2_on_re)        
       
!        part1 = (wfim+wfimn) !*
!     &             (f_1_on_im*f_2_on_im  - f_1_on_re*f_2_on_re) 
!        part2 = (wfre+wfren) !*
!     &             (f_2_on_re*f_2_on_im  + f_1_on_im*f_2_on_re)        

        
        un_k3_im = (part1 - part2)*qq2*qq3
  
        return
	end





	function  f_re(NN,x)
        dimension x(*)
        dimension pv1(3), pv2(3), pvn1(3), pvn2(3)
        common/par/pi,pm,pmp,pmn,tm,eb
	common/knocked/  p_f_x,  p_f_y,  p_f_z
        common/missing/  p_m_x,  p_m_y,  p_m_z
        common/recoil_r/ p_r_x,  p_r_y,  p_r_z
        common/recoil_s/ p_s_x,  p_s_y,  p_s_z
        common/conf/kt1,ks1,kt2,ks2,kt3,ks3,kj
        common/delta2/delta0,delta2,delta3
        common/sres/irs,s_r,s_s
        common/nchanal/nal

        nnn =NN
        f_re = 0.0
        qq2 = x(1) 
        phiqq2= x(2)
        qq3 = x(3)
        phiqq3 = x(4)
        
        tilda2 = delta0 - delta3
        tilda3 = delta0 - delta2
         wfre = 0.0
         wfim = 0.0
         wfren = 0.0
         wfimn = 0.0


	q2_x      = qq2*cos(phiqq2)
	q2_y      = qq2*sin(phiqq2)
       
	q3_x      = qq3*cos(phiqq3)
	q3_y      = qq3*sin(phiqq3)

 	pv1(3)   = p_m_z + delta0
	pv1(2)   = p_m_y + q2_y + q3_y
	pv1(1)   = p_m_x + q2_x + q3_x
	p_1      = sqrt(pv1(1)**2+pv1(2)**2+pv1(3)**2)

	pv2(3)   = p_r_z - tilda2
        pv2(2)   = p_r_y - q2_y
	pv2(1)   = p_r_x - q2_x
	p_2      = sqrt(pv2(1)**2+pv2(2)**2+pv2(3)**2)
	
        pvn1(3)   = pv1(3) 
	pvn1(2)   = pv1(2)
	pvn1(1)   = pv1(1)
	pn_1      = p_1 

	pvn2(3)   = p_r_z - delta2
        pvn2(2)   = pv2(2)
	pvn2(1)   = pv2(1)
	pn_2      = sqrt(pvn2(1)**2+pvn2(2)**2+pvn2(3)**2)



        if(irs.eq.221)then
*************  pp case  rescattered particle is proton ----        
        its = 1
        t2  = -qq2**2
        call  f_NN_on(s_r,t2,f_1_on_re,f_1_on_im,its)   
*************** pn case spectator particle is neutron        
        its = -1
        t3  = -qq3**2
        call  f_NN_on(s_s,t3,f_2_on_re,f_2_on_im,its)

        elseif(irs.eq.212)then
*************  pn case  rescattered particle is neutron ----
        its = -1
        t2  = -qq2**2
        call  f_NN_on(s_r,t2,f_1_on_re,f_1_on_im,its)
*************** pp case spectator particle is proton
        its = 1
        t3  = -qq3**2
        call  f_NN_on(s_s,t3,f_2_on_re,f_2_on_im,its)   
       
        elseif(irs.eq.122)then
*************  np case  rescattered particle is proton ----
        its = -1
        t2  = -qq2**2
        call  f_NN_on(s_r,t2,f_1_on_re,f_1_on_im,its)
*************  np case  spectator particle is proton ----
        its = -1
        t3  = -qq3**2
        call  f_NN_on(s_s,t3,f_2_on_re,f_2_on_im,its)
        endif

      
**************************************************************
        call wf_he3_al(nal,kt1,ks1,pv1,kt2,ks2,pv2,kt3,ks3,kj,
     &               wfre,wfim,0)
       
	call wf_he3_al(nal,kt1,ks1,pvn1,kt2,ks2,pvn2,kt3,ks3,kj,
     &               wfren,wfimn,0)        
       
        
       
        part1 = (wfre+wfren) *
     &             (f_1_on_im*f_2_on_im  - f_1_on_re*f_2_on_re) 
        part2 = (wfim+wfimn) *
     &             (f_1_on_re*f_2_on_im  + f_1_on_im*f_2_on_re)        
        
        f_re  = (part1 + part2)*qq2*qq3

        return
	end


        function  f_im(NN,x)
        dimension x(4)
        dimension pv1(3), pv2(3), pvn1(3), pvn2(3)
	common/q2_phi/qq2,phiqq2
        common/par/pi,pm,pmp,pmn,tm,eb
	common/knocked/  p_f_x,  p_f_y,  p_f_z
        common/missing/  p_m_x,  p_m_y,  p_m_z
        common/recoil_r/ p_r_x,  p_r_y,  p_r_z
        common/recoil_s/ p_s_x,  p_s_y,  p_s_z
        common/conf/kt1,ks1,kt2,ks2,kt3,ks3,kj
        common/delta2/delta0,delta2,delta3
        common/sres/irs,s_r,s_s
        common/nchanal/nal
        f_im = 0.0
        qq2 = x(1) 
        phiqq2= x(2)
        qq3 = x(3)
        phiqq3 = x(4)
        nnn = NN
       
        tilda2 = delta0 - delta3
        tilda3 = delta0 - delta2
         wfre = 0.0
         wfim = 0.0
         wfren = 0.0
         wfimn = 0.0

	q2_x      = qq2*cos(phiqq2)
	q2_y      = qq2*sin(phiqq2)
       
	q3_x      = qq3*cos(phiqq3)
	q3_y      = qq3*sin(phiqq3)

 	pv1(3)   = p_m_z + delta0
	pv1(2)   = p_m_y + q2_y + q3_y
	pv1(1)   = p_m_x +  q2_x + q3_x
	p_1      = sqrt(pv1(1)**2+pv1(2)**2+pv1(3)**2)

	pv2(3)   = p_r_z - tilda2
        pv2(2)   = p_r_y - q2_y
	pv2(1)   = p_r_x - q2_x
	p_2      = sqrt(pv2(1)**2+pv2(2)**2+pv2(3)**2)
	
        pvn1(3)   = pv1(3) 
	pvn1(2)   = pv1(2)
	pvn1(1)   = pv1(1)
	pn_1      = p_1 

	pvn2(3)   = p_r_z - delta2
        pvn2(2)   = pv2(2)
	pvn2(1)   = pv2(1)
	pn_2      = sqrt(pvn2(1)**2+pvn2(2)**2+pvn2(3)**2)

        if(irs.eq.221)then
*************  pp case  rescattered particle is proton ----        
        its = 1
        t2  = -qq2**2
        call  f_NN_on(s_r,t2,f_1_on_re,f_1_on_im,its)   
*************** pn case spectator particle is neutron        
        its = -1
        t3  = -qq3**2
        call  f_NN_on(s_s,t3,f_2_on_re,f_2_on_im,its)

        elseif(irs.eq.212)then
*************  pn case  rescattered particle is neutron ----
        its = -1
        t2  = -qq2**2 
        call  f_NN_on(s_r,t2,f_1_on_re,f_1_on_im,its)
*************** pp case spectator particle is proton
        its = 1
        t3  = -qq3**3
        call  f_NN_on(s_s,t3,f_2_on_re,f_2_on_im,its)   
       
        elseif(irs.eq.122)then
*************  np case  rescattered particle is proton ----
        its = -1
        t2  = -qq2**2
        call  f_NN_on(s_r,t2,f_1_on_re,f_1_on_im,its)
*************  np case  spectator particle is proton ----
        its = -1
        t3  = -qq3**2
        call  f_NN_on(s_s,t3,f_2_on_re,f_2_on_im,its)
        endif

 
**************************************************************
        call wf_he3_al(nal,kt1,ks1,pv1,kt2,ks2,pv2,kt3,ks3,kj,
     &               wfre,wfim,0)

         
	call wf_he3_al(nal,kt1,ks1,pvn1,kt2,ks2,pvn2,kt3,ks3,kj,
     &               wfren,wfimn,0)        
        
        
       
        part1 = (wfim+wfimn) *
     &             (f_1_on_im*f_2_on_im  - f_1_on_re*f_2_on_re) 
        part2 = (wfre+wfren) *
     &             (f_1_on_re*f_2_on_im  + f_1_on_im*f_2_on_re)        
        
        f_im = (part1 - part2)*qq2*qq3

        return
	end

       subroutine 
     & wf_he3_al(nal,mt1,ms1,pv1,mt2,ms2,pv2,mt3,ms3,kj,wfre,wfim,iflag)
*************************************************************************
* calculates the real and impaginary part of 3He  wave function 
* summing up to the channel number nal 
* nal -    number of channel
* mt1,mt2,mt3 - isospin projections of 1,2,3 nucleons -1-neutron,1-proton
* ms1,ms2,ms3 - spin projection of 1,2,3 nucleon -1-> -1/2, 1-> 1/2
* kj - spint projection of he3 -1/2, 1-> 1/2
* pv1,pv2 - three vectors of nucleon 1 and 2 in GeV/c
* wfre,wfim - re and im part of the wave function in GeV-3
* iflag = 1- reads the data file, 2- resets the projection of the total spin, 
*         0- calculates
* momenta in Gev
* wave GeV^{-3}
***********************************************************************
       use getwavemod
       dimension pv1(3),pv2(3)
       CHARACTER(LEN=80) :: wavein
       COMPLEX wave
       wfre = 0.0
       wfim = 0.0
       fmg = 0.197326
       mbj =  kj
       if(iflag.eq.1.)then
       WAVEIN = 'he_3.av18+tml5156.jmax=6.esuche.cdep_app.fad.c.form'
       CALL readwave(WAVEIN,1,.false.)
       write(6,*)wavein
       return
       elseif(iflag.eq.2)then          
       CALL mbjreset(mbj,.false.)
       wfre = 0.0
       wfim = 0.0      
       return
       endif

      p1x = pv1(1)/fmg
      p1y = pv1(2)/fmg
      p1z = pv1(3)/fmg

      p2x = pv2(1)/fmg
      p2y = pv2(2)/fmg
      p2z = pv2(3)/fmg

      p3x = -(p1x+p2x)
      p3y = -(p1y+p2y)
      p3z = -(p1z+p2z)

      wave=
     X getwave_s(nal,p1x,p1y,p1z,ms1,mt1,p2x,p2y,p2z,ms2,mt2,ms3,mt3)
     X+getwave_s(nal,p2x,p2y,p2z,ms2,mt2,p3x,p3y,p3z,ms3,mt3,ms1,mt1)
     X+getwave_s(nal,p3x,p3y,p3z,ms3,mt3,p1x,p1y,p1z,ms1,mt1,ms2,mt2)
      wfre =  real(wave)/fmg**3
      wfim = aimag(wave)/fmg**3
*      write(6,*)wave
      return
      end
      


